package edu.toronto.cs.ctl;

import edu.toronto.cs.algebra.*;

/**
 ** This is a CTL node representing a lattice value.
 **/
public class CTLLatticeNode extends CTLAbstractNode
{

  int value;
  FiniteLattice lattice;  

  /**
   ** Construct a lattice node from the index of the lattice value and
   ** the lattice itself.
   **/
  protected CTLLatticeNode (int v, FiniteLattice lat)
  {
    super ();
    value = v;
    lattice = lat;
  }

  public String toString ()
  {
    return lattice.getElementKeyByIdx (value).toString ();
  }

  public int getLatIdx ()
  {
    return value;
  }
  
  public FiniteLattice getLattice ()
  {
    return lattice;
  }

  public void accept (CTLVisitor v, Object s)
  {
    v.visitLatticeNode (this, s);
  }
  
}
