package edu.toronto.cs.ctl;

import edu.toronto.cs.algebra.*;
import edu.toronto.cs.mvset.*;

/**
 ** This is a CTL node representing an MvSet.
 **/
public class CTLMvSetNode extends CTLAbstractNode
{

  MvSet mvset;

  /**
   ** Construct a CTL node associated with a particular MvSet.
   **/
  protected CTLMvSetNode (MvSet set)
  {
    super ();
    mvset = set;
  }

  public String toString ()
  {
    return mvset.toString ();
  }

  public MvSet getMvSet ()
  {
    return mvset;
  }

  public void accept (CTLVisitor visitor, Object stateinfo)
  {
    visitor.visitMvSetNode (this, stateinfo);
  }
  
}
