package edu.toronto.cs.ctl;

import java.util.*;

/**
 ** This is an abstract CTL node.
 **/
public interface CTLVisitor
{
  public void visit (CTLNode n, Object stateinfo);
  
  public void visitAbstractNode (CTLAbstractNode n, Object stateinfo);

  public void visitAFNode (CTLAFNode node, Object stateinfo);
  public void visitAGNode (CTLAGNode node, Object stateinfo);
  public void visitAUNode (CTLAUNode node, Object stateinfo);
  public void visitAUiNode (CTLAUiNode node, Object stateinfo);
  public void visitAWNode (CTLAWNode node, Object stateinfo);
  public void visitAXNode (CTLAXNode node, Object stateinfo);
  public void visitAndNode (CTLAndNode node, Object stateinfo);
  public void visitAtomNode (CTLAtomNode node, Object stateinfo);
  public void visitEFNode (CTLEFNode node, Object stateinfo);
  public void visitEGNode (CTLEGNode node, Object stateinfo);
  public void visitEUNode (CTLEUNode node, Object stateinfo);
  public void visitEUiNode (CTLEUiNode node, Object stateinfo);
  public void visitEWNode (CTLEWNode node, Object stateinfo);
  public void visitEXNode (CTLEXNode node, Object stateinfo);
  public void visitEqualsNode (CTLEqualsNode node, Object stateinfo);
  public void visitIffNode (CTLIffNode node, Object stateinfo);
  public void visitImplNode (CTLImplNode node, Object stateinfo);
  public void visitLatticeNode (CTLLatticeNode node, Object stateinfo);
  public void visitMvSetNode (CTLMvSetNode node, Object stateinfo);
  public void visitNegNode (CTLNegNode node, Object stateinfo);
  public void visitNode (CTLNode node, Object stateinfo);
  public void visitOrNode (CTLOrNode node, Object stateinfo);
  public void visitOverNode (CTLOverNode node, Object stateinfo);
  public void visitPlaceholderNode (CTLPlaceholderNode node, Object stateinfo);
  public void visitPreEXNode (CTLPreEXNode node, Object stateinfo);
  public void visitUnderNode (CTLUnderNode node, Object stateinfo);

  
}

