package edu.toronto.cs.ctl.parser;

import java_cup.runtime.Symbol;

%%

%cup

%eofval{
  return new Symbol (Sym.EOF);
%eofval}

%%

";" { return new Symbol (Sym.SEMI); }
"(" { return new Symbol (Sym.LP); }
")" { return new Symbol (Sym.RP); }
"[" { return new Symbol (Sym.LB); }
"]" { return new Symbol (Sym.RB); }
"{" { return new Symbol (Sym.LCB); }
"}" { return new Symbol (Sym.RCB); }
"!" { return new Symbol (Sym.NOT); }
"=" { return new Symbol (Sym.EQUAL); }
"!=" { return new Symbol (Sym.NOTEQUAL); }
/\\|"&" { return new Symbol (Sym.AND); }
\\/|"|" { return new Symbol (Sym.OR); }
"->" { return new Symbol (Sym.FWIMPLIES); }
"<-" { return new Symbol (Sym.BWIMPLIES); }
"<->" { return new Symbol (Sym.IFF); }
">=" { return new Symbol (Sym.OVER); }
"<=" { return new Symbol (Sym.UNDER); }
"EX" { return new Symbol (Sym.EX); }
"AX" { return new Symbol (Sym.AX); }
"EF" { return new Symbol (Sym.EF); }
"AF" { return new Symbol (Sym.AF); }
"EG" { return new Symbol (Sym.EG); }
"AG" { return new Symbol (Sym.AG); }
"A" { return new Symbol (Sym.A); }
"E" { return new Symbol (Sym.E); }
"U" { return new Symbol (Sym.UNTIL); }
"W" { return new Symbol (Sym.WEAK); }
\? { return new Symbol (Sym.QNMRK); }

"." { return new Symbol (Sym.DOT); }
"," { return new Symbol (Sym.COMMA); }
[A-Za-z_][A-Za-z0-9_]* { return new Symbol (Sym.ALPHANUM, yytext ()); }
[0-9]+ { return new Symbol (Sym.NUMBER, yytext ()); }
[ \t\r\n\f] { /* ignore white space. */ }
. { System.err.println ("Illegal character: " + yytext ()); }




