package edu.toronto.cs.experiments;

import edu.toronto.cs.util.Chaos;
import java.util.Iterator;
import org.apache.log4j.*;

public class SparseInputMVOutput extends SparseInputFunction {

    static Category log = 
	Category.getInstance("edu.toronto.cs.experiments.SparseInputBoolOutput");

    static {
	BasicConfigurator.configure();
    }

    public SparseInputMVOutput(int m, int k, float sp, float dis) {
	super(m,k, sp, dis);
    }


    public Function clone (int m_, int k_) {
	return new SparseInputMVOutput(m_, k_, sparsity, disTheta);
    }

    protected int fillRow(float disag) {
	// assume that disagreement is above threshold!
	if (Chaos.nextThreshold(sparsity))
	    {
		int curr = 1+Chaos.nextUpTo(m-1);
		return curr;
	    }
	else return 0;
    }
    

    public static void main(String argv[]) {

	Function fn = new SparseInputMVOutput(3,4, (float)0.1, (float)0.25);
	Iterator zoobert = fn.getAllPoints();
	while (zoobert.hasNext()) {
	    zoobert.next();
	}
    }
}
