package edu.toronto.cs.experiments;

import java.util.Iterator;
import java.util.Map;
import java.util.HashMap;
import org.apache.log4j.*;

public abstract class TableFunction extends Function {

    static protected Category log = 
	Category.getInstance("edu.toronto.cs.experiments.TableFunction");

    int table[];
    Decoder dec;
    public TableFunction(int m_, int k_) {
	super(m_, k_);
  	table = new int[powr(m,k)];
  	dec = new DigitDecoder(m, k);
	fill();
    }

    class TableFunctionIterator implements Iterator {
	int i;
	
	public TableFunctionIterator() {

	    i=0;
	    while (i<table.length && table[i]==0)
		i++;
	    log.debug("First nonzero position: "+i);
	}

	public boolean hasNext() {
	    return i<table.length;
	}

	public Object next() {
	    Entry res = new Entry(dec.decode(new Integer(i)),
				  table[i++]);
	    while (i<table.length && table[i]==0)
		i++;
	    log.debug("current value: "+res+", next nonzero is at: "+i);
	    return res;
	}

	public void remove() { table[i]=0; }
	
    }

    public Iterator getAllPoints() {
	return new TableFunctionIterator();
    }


    public Function embed(int newm, int mapping[]) {

	TableFunction res = (TableFunction)clone(newm, k);
	log.debug("Embedding "+m+" into "+newm);
	// zero the function
	for (int i=0; i<res.table.length; i++)
	    res.table[i] = 0;
	
	Iterator it = getAllPoints();
	while (it.hasNext()) {
	    Entry curr = (Entry) it.next();
	    log.debug("Mapping "+curr.output+" to "+mapping[curr.output]);
	    int emb[] = new int[k];
	    for (int i=0; i<k; i++) 
		emb[i] = mapping[curr.inputs[i]];
	    res.table[res.dec.encode(emb)] = mapping[curr.output];
	}
	return res;
    }

}
