package edu.toronto.cs.gui;

import java.util.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;


public class ColourCellRenderer implements TableCellRenderer
{
  SolidBoxCanvas c;
  
  public ColourCellRenderer ()
  {
    c = new SolidBoxCanvas (Color.black, false);
  }

  public JComponent getComponent ()
  {
    return c;
  }
  
  public Component getTableCellRendererComponent 
    (JTable table, Object value, boolean isSelected, boolean hasFocus, 
     int row, int column) 
  {
    // XXX debugging hack, remove:
    if (value instanceof String)
      c.setAs (Color.black, isSelected);
    else
      c.setAs ((Color)value, isSelected);
    return c;
  }
  
  public static class SolidBoxCanvas extends JComponent
  {
    Color colour;
    boolean selected;

    public SolidBoxCanvas (Color _colour, boolean _selected)
    {
      colour = _colour;
      selected = _selected;
      //  this.setPreferredSize (new Dimension (100, 100));
      //this.add (Box.createHorizontalStrut (150));
    }

    public void setAs (Color _colour, boolean _selected)
    {
      colour = _colour;
      selected = _selected;
    } 

    public Dimension getPreferredSize ()
    {
      return new Dimension (200, 100);
    }
    
    public void paint (Graphics g)
    {
      g.setColor (colour);
      g.fillRect (0, 0, getWidth (), getHeight ());
      if (!selected)
	return;
      g.setColor (Color.black);
      g.setXORMode (Color.white);
      g.drawRect (1, 1, getWidth ()-2, getHeight ()-2);
      g.drawRect (2, 2, getWidth ()-4, getHeight ()-4);
    }

    public void update (Graphics g)
    {
      //paint (g);
    }
    
    public void repaint ()
    {
    }
    
  }
    
}
  








