package edu.toronto.cs.gui;

import edu.toronto.cs.modelchecker.*;

import java.util.*;
import java.io.*;
import javax.swing.*;
//import javax.swing.event.*;
import javax.swing.filechooser.*;

import java.awt.*;
import java.awt.event.*;

/**
 ** The "Open generic model" dialog window.
 **/
public class OpenGenericModel extends JDialog
{
  // input fileds for class name and parameters
  JTextField classname, parameters;

  // the done and cancel buttons
  JButton done, cancel;

  // parsed input
  String [] input = null;

  public OpenGenericModel (String prefix)
  {
    super ((Frame) null, "Open BDD Model", true);

    // text fileds
    classname = new JTextField (prefix);
    parameters = new JTextField ();

    // the two buttons at the bottom of the screen - done and cancel
    JPanel donecancel = new JPanel ();
    donecancel.setLayout (new BoxLayout (donecancel, BoxLayout.X_AXIS));
    done = new JButton ("Done");
    done.setMnemonic (KeyEvent.VK_D);
    done.addActionListener
      (new ActionListener ()
       {
	 public void actionPerformed (ActionEvent e)
	   {		
	     // put all the input in one string
	     String allinput = classname.getText () + " " +
	       parameters.getText ();
	     
	     // break it into tokens and dump it into an array
	     StringTokenizer strtokens = new StringTokenizer (allinput);
	     input = new String [strtokens.countTokens ()];

	     for (int i = 0; i < input.length; i++)
	       input [i] = strtokens.nextToken ();

	     setVisible (false);
	   }
       });
    cancel = new JButton ("Cancel");
    cancel.setMnemonic (KeyEvent.VK_C);
    cancel.addActionListener (new ActionListener ()
			      {
				public void actionPerformed (ActionEvent e)
				  {				  
				    input = null;
				    setVisible (false);
				  }
			      });
    donecancel.add (done);
    donecancel.add (Box.createGlue ());
    donecancel.add (cancel);

    // make the layout a bit nicer (more space between everything)
    JPanel all = new JPanel ();
    all.setLayout (new BoxLayout (all, BoxLayout.Y_AXIS));
    all.setBorder (StandardFiller.makeWideEmptyBorder ());

    all.add (new JLabel ("Enter the class name here:"));
    all.add (classname);
    all.add (StandardFiller.makeVstrut ());
    all.add (new JLabel ("Enter parameters here:"));
    all.add (parameters);
    all.add (StandardFiller.makeVstrut ());
    all.add (donecancel);

    // set alignment
    GUIutil.alignAllX (all.getComponents (), Component.LEFT_ALIGNMENT);

    getContentPane ().add (all);
  }

  /**
   ** Get the parsed input.
   ** @return the input as an array of Strings or null (if 'Cancel'
   ** is pressed).
   **/
  String [] getInput ()
  {
    return input;
  }
}
