package edu.toronto.cs.keg;

import java.util.*; // We all love java.util ...

import edu.toronto.cs.ctl.*;
import edu.toronto.cs.util.dgraph.*;

public class KEGCtlNodeFactory extends DGlobalUniqueFactory
{

  //  Map allNodes;

  public KEGCtlNodeFactory ()
    {
      super ();
    }

  public KEGCtlNode createNode (KEGCtlNode target, CTLNode _ctl, Set _states)
    {
      KEGCtlNode result = (KEGCtlNode) obtainNode (target, _ctl);
      result.makeTerminal (_states);
      return result;
    }

  public KEGCtlNode createNode (KEGCtlNode target, CTLNode _ctl)
    {
      KEGCtlNode result = (KEGCtlNode) obtainNode (target, _ctl);
      return result;
    }

  public DGUniqueNode instantNode (Object ident)
  {
    return new KEGCtlNode ((CTLNode)ident, this);
  }

  public boolean addOk (DGNode node)
  {
    if (node instanceof KEGCtlNode)
      {
	((KEGCtlNode)node).owner = this;
	doAdd (node);
	return true;
      }
    return false;
  }
  
  /*
  private KEGCtlNode obtainNode (CTLNode _ctl, Set _states)
    {
      if (allNodes.containsKey(_ctl))
	return ((KEGCtlNode)allNodes.get(_ctl));
      return new KEGCtlNode (_ctl, _states, this);
    }
 
  private KEGCtlNode obtainNode (CTLNode _ctl)
    {
      if (allNodes.containsKey(_ctl))
	return ((KEGCtlNode)allNodes.get(_ctl));
      return new KEGCtlNode (_ctl, this);
    }
  */
  
}








