package edu.toronto.cs.keg;

import java.util.*;

import edu.toronto.cs.util.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.ctl.*;

// XXX ok, this should not be done like this after all, I
// think. RATHER, there should a state class (forgotten pattern name),
// which would encapsulate on what ctl and state a function was called
// as well as all the result addition functions. This class would be
// the sole thing that the KEGSimplifiers would receive in a call, and
// the sole thing they'd use to add their results.

// XXX cont'd) This would allow absolutely everything to be rolled
// into a nice simple interface which would only have things like
// "whatStateAmILookingAt ()" and "whatCtl ()", and "ohIveFoundSomeCtl
// (CTLNode andhereitis)", etc. Much more elegant, no?  And much less
// susceptible to massive changes in the nature of the structure which is
// storing the result.* -CDTW

// *which is, at the moment, DGraph etc., but could reasonably be
// imagined to be any manner of thing...

// Shall I write this?

public class KegUtils
{
  static Logger log = new Logger (KegUtils.class.getName ());

  public static void addState (DGNode state, DGNode formula, 
				MvState mvstate, int trans, CTLNode ctl) 
  {
    //System.out.println ("Add state.");
    
    Set tstates = ((KEGCtlNode)formula).getStates ();
    tstates.add (mvstate);
    ((KEGCtlNode)formula).makeTerminal (tstates);

    KEGStateNodeFactory factory = (KEGStateNodeFactory) state.getFactory ();
    // -- create a state
    KEGStateNode nextState = 
      factory.createNode ((KEGStateNode)state, mvstate);
    DGraph ctlgraph = new DGraph (new KEGCtlNodeFactory ());
    ctlgraph.addRootNode (((KEGCtlNodeFactory)
			   ctlgraph.getFactory ()).createNode (ctl));
    nextState.setCTLGraph (ctlgraph);
    //System.out.println (""+nextState.getCTLGraph ());
    ((KEGStateNode) state).add (nextState, trans);
  }

  public static void addCtl (DGNode state, DGNode formula, CTLNode ctl)
  {
    //System.out.println ("addctl");
    KEGCtlNodeFactory factory = (KEGCtlNodeFactory) formula.getFactory ();
    formula.add (factory.createNode (ctl));
  }
  
}




















