/*
 * KVWCtlExpression.java
 *
 * Created on November 24, 2001, 7:28 PM
 */

package edu.toronto.cs.kegvis;
import edu.toronto.cs.keg.*;
import java.util.*;
import edu.toronto.cs.ctl.*;

/**
 *
 * @author  bwong
 * @version
 */
public class KVWCtlExpression implements KVCtlExpression {
  
  KEGCtlNode ctlnode;
  
  /** Ordered KEGCtlNode list for successors */
  Vector successors;
  
  HashMap flags;
  
  /** Creates new KVWCtlExpression */
  public KVWCtlExpression(KEGCtlNode ctlnode) {
    this.ctlnode = ctlnode;
    successors = new Vector(ctlnode.getSuccessors());
  }
  
  public int numSuccessors() {
    return successors.size();
  }
  
  public String toString() {
    return ctlnode.getCTL().toString();
  }
  public String toHtml() {
    String tempStr;
    // TODO: how to output HTML for the links?
    String aopen = "<a href=\"/kegvis/KVWServlet?command=pickleft\">";
    String aclose = "</a>";
    String bopen = "<a href=\"/kegvis/KVWServlet?command=pickright\">";
    String bclose = "</a>";
    // assumes that the only branching known is due to /\ or \/
    if (ctlnode.getCTL() instanceof CTLEqualsNode) {
      if (ctlnode.getCTL().getLeft() instanceof CTLAndNode) {//+ ctlnode.getCTL().getLeft().getLeft() 
        tempStr = "(" + aopen + ((KEGCtlNode)successors.get(0)).getCTL() + aclose +
        " /\\ " + bopen + ((KEGCtlNode)successors.get(1)).getCTL() + bclose + ")" +
        " = " + ctlnode.getCTL().getRight();
        return tempStr;
      }
      else if (ctlnode.getCTL().getLeft() instanceof CTLOrNode) {
        tempStr = "(" + aopen + ctlnode.getCTL().getLeft().getLeft() + aclose +
        " \\/ " + bopen + ctlnode.getCTL().getLeft().getRight() + bclose + ")" +
        " = " + ctlnode.getCTL().getRight();
        return tempStr;
      }
    }
    
    // not /\ or \/, so just return string
    tempStr = toString();
    return tempStr;
  }
  
  /** Getter for property flags.
   * @return Value of property flags.
   */
  public HashMap getFlags() {
    return flags;
  }
  
  /** Setter for property flags.
   * @param flags New value of property flags.
   */
  public void setFlags(HashMap flags) {
    this.flags = flags;
  }
  
  public java.lang.String nextOp() {
    return ctlnode.getCTL().getClass().getName();
  }
  
  /** Getter for property successors.
   * @return Value of property successors.
   */
  public java.util.Vector getSuccessors() {
    return successors;
  }
  
}
