package edu.toronto.cs.lift;

import edu.toronto.cs.smv.*;
import edu.toronto.cs.mvset.*;

public class ButtonR extends SMVModule
{
  static final int PRESSED = 0;

  MvSet reset = null;

  MvSet pressedCond = null;
  int pressedCondVal = -1;

  public ButtonR (String _name)
  {
    super (_name);
    vars = new String[]{"pressed"};
  }
  

  public void setReset (MvSet v)
  {
    reset = v;
  }
  
  public void setPressedCond (MvSet cond, int val)
  {
    pressedCond = cond;
    pressedCondVal = val;
  }
  
  public MvSet getPressed ()
  {
    if (pressedCond == null)
      return cur (PRESSED);
    
    return new CaseStatement ().
      addCase (pressedCond.and (cur (PRESSED)), cur (PRESSED, bot)).
      addDefault (cur (PRESSED)).compute ();
    
    
  }
  
  
  public MvSet computeTrans ()
  {
    System.out.println ("Computing trans for: " + getName ());
    return computePressed ();
  }
  

  public MvSet computePressed ()
  {
    /***
	next (pressed) := case
	                   reset: false;
			   pressed: true;
			   1: {true, false};
                         esac
    */
    return new CaseStatement ().
      addCase (reset, next (PRESSED, bot)).
      addCase (cur (PRESSED), next (PRESSED, top)).
      addDefault (next (PRESSED).or (next (PRESSED, bot))).compute ();
  }
  

  public MvState initializeInitState (MvState initState)
  {
    // -- init (pressed) := false
    initState.setValue (getVarOrder (PRESSED), bot);
    return initState;
  }
  
    
}
