package edu.toronto.cs.lift;

import java.util.*;

import edu.toronto.cs.smv.*;
import edu.toronto.cs.mvset.*;
import edu.toronto.cs.util.*;


// XXX for testing only
import edu.toronto.cs.modelchecker.AlternatePropOrder;
import edu.toronto.cs.algebra.*;


/****
 **** Lift + ef + tt-full
 **** Lift with exec.feat + tt-full.feat
 ****/

public class LiftRTTEF extends LiftREFTT
{
  
  public LiftRTTEF (String _name, int _floors, MainLiftRTTEF _main)
  {
    super (_name, _floors, _main);
    System.out.println ("Lift + TT + EF");
  }



  public MvSet computeVarIsPriorityCall (int varIdx, int varWidth, int varTopVal,
				  ButtonR[] btns)
  {
    System.out.println ("Calling computeVarIsPriorityCall in TT + EF");
    CaseStatement caseStmt = new CaseStatement ();
    
    // -- compute the case statement
    // -- lift.ef = i & btns[i].pressed : i
    for (int i = 1; i <= topFloor; i++)
      caseStmt.addCase (computeNatEquals (efIdx, efWidth, i).
			and (btns [i-1].cur (ButtonR.PRESSED)),
			computeNatEquals (varIdx, varWidth, i));

    caseStmt.
      addDefault (computeVarIsCall (varIdx, varWidth, varTopVal, btns));

    return caseStmt.compute ();
  }
  

  
  MvSet computePriorityCallEquals (int num, ButtonR[] btns)
  {
    /***
     *** priority_call = 0 iff none of the condition for priority_call hold
     *** and the landing_call = 0
     ***/
    MvSet result = mvBot;

    // -- result is (lift.ef = 1 & landingBut1.pressed) | 
    // --           (lift.ef = 2 & landingBut2.pressed) | ...
    for (int i = 1; i <= topFloor; i++)
      result = result.or 
	(computeNatEquals (efIdx, efWidth, i).
	 and (btns [i-1].cur (ButtonR.PRESSED)));

    result = result.not ();

    return result.and (computeCallEquals (num, btns));
  }
}




