package edu.toronto.cs.mvset;


import edu.toronto.cs.algebra.*;

public abstract class AbstractMvSetFactory implements MvSetFactory
{
  public MvSet createCase (int argIdx, MvSet[] children)
  {
    FiniteLattice lattice = getLattice ();
    int top = lattice.idtimesIdx ();

    MvSet result = createConstant (lattice.idplusIdx ());

    for (int i = 0; i < children.length; i++)
      result = result.or (var (argIdx, i, top).and (children [i]));
    return result;
  }

}
