package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.xkripke.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.mvset.MvState;
import edu.toronto.cs.util.*;

public class DVGenEdgeVisitor extends PrettyGraphEdgeVisitorAncestor
{
  static Logger log = new Logger ("DVGenEdgeVisitor");

  Map edgesToDV;
 
  NamingScheme labeller;
  String snl = "g";
  
  public DVGenEdgeVisitor ()
  {
    edgesToDV = new HashMap ();
    labeller = new NamingScheme.QuickNumberingScheme ();
  }
  
  public void doEdge (DGEdge edge, Object stateinfo)
  {
      visit (edge, stateinfo);
  }

  public Collection getEdges ()
  {
    log.debug (edgesToDV);
    return edgesToDV.values (); 
  }

  public Object clone ()
  {
    DVGenEdgeVisitor v = new DVGenEdgeVisitor ();
    v.edgesToDV = (Map)((HashMap)edgesToDV).clone ();
    return v;
  }

  public void visitPrettyGraphEdge (PrettyGraphEdge edge, Object stateinfo)
  {
    edgesToDV.put(edge, new DVEdge (edge, labeller, snl));
  }

  public void setSuperNodeLabel (String s)
  {
    snl = s;
  }
  

  public void visitPrettyKegEdge (PrettyKegEdge edge, Object stateinfo)
  {
    visitPrettyGraphEdge (edge, stateinfo);
  }

  public void visitPrettyGraphMDDEdge (PrettyGraphMDDEdge edge, 
				       Object stateinfo)
  {
    edgesToDV.put(edge, new DVEdge (edge, labeller, snl));
  }

  public void visitPrettyXKTransition (PrettyXKTransition edge, 
				       Object stateinfo)
  {
    visitPrettyGraphEdge (edge, stateinfo);
  }

}
