package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.xkripke.*;
import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.mvset.MvState;
import edu.toronto.cs.algebra.*;

public class PrettyGraphXKEdger extends PrettyGraphEdgeVisitorAncestor
{
  Map colorMap;
  
  public static Object STS_COLOUR = PrettyKegEdgeColouring.STS_COLOUR;
  public static int STS_LINETHICK = PrettyKegEdgeColouring.STS_LINETHICK;
  public static int STS_LINENUM = PrettyConstants.SINGLE_LINE;
  public static int STS_HEAD = PrettyKegEdgeColouring.STS_HEAD;
  public static boolean LABEL_STS = PrettyKegEdgeColouring.LABEL_STS;
  
  public PrettyGraphXKEdger (Map colourMap)
  {
    colorMap = colourMap; // grin...
  }

  public void visitPrettyXKTransition (PrettyXKTransition edge, 
				       Object stateinfo)
  {
    // Right.
    System.out.println ("Colouring state transition.");
    Object val = edge.getXK ().getValue ();
    if (colorMap.get (val) != null)
      edge.setColour (colorMap.get (val));
    else
      edge.setColour (PrettyConstants.defaultColour);
    
     edge.setLineNum (STS_LINENUM)
      .setLineThickness (STS_LINETHICK)
      .setArrowDown (STS_HEAD);

     if (LABEL_STS)
      edge.setLabel (val.toString ()); 
  }
}


