package edu.toronto.cs.prettygraph;

import java.util.*;

import edu.toronto.cs.util.dgraph.*;
import edu.toronto.cs.util.*;
import edu.toronto.cs.keg.*;
import edu.toronto.cs.mvset.MvState;

// Sadly necessary:
import edu.toronto.cs.modelchecker.*;

public class PrettyNaiveStateLabelStrategy 
  implements PrettyStateLabelStrategy
{
  
  String standardBanner = "";
  String standardFooter = "";
  PropOrderIf props;
  
  public PrettyNaiveStateLabelStrategy (PropOrderIf _props)
  {
    props = _props;
  }

  protected String getBanner (KEGStateNode node, Object stateinfo)
  {
    return standardBanner;
  }

  protected String getFooter (KEGStateNode node, Object stateinfo)
  {
    return standardFooter;
  }

  public PrettyStateLabelStrategy setBanner (String b)
  {
    standardBanner = b;
    return this;
  }
  
  public PrettyStateLabelStrategy setFooter (String f)
  {
    standardFooter = f;
    return this;
  }
  
  public Object getLabel (KEGStateNode node, Object stateinfo)
  {
    
    return new PrettyBaseKegLabel (props, node.getState ())
      .setBanner (getBanner (node, stateinfo))
      .setFooter (getFooter (node, stateinfo))
      .addToDesired (getInterestingProps (node, stateinfo));
  }

  protected Set getInterestingProps (KEGStateNode node, Object stateinfo)
  {
    Set s = new HashSet ();
    for (int i =0; i < props.size ()/2; i++)
      {
	s.add (new Integer (i));
      }
    return s;
  }
}

  
    






