package edu.toronto.cs.util.dgraph;

import java.util.*;
import edu.toronto.cs.util.*;

public class DGDepthTraverse
{
  static Logger log = new Logger ("DGDepthTraverse");

  List nodes;

  public static Iterator getIterator (DGNode dg)
  {
    log.debug ("Start Hi! DGNode");
    DGDepthTraverse dt = new DGDepthTraverse (dg);
    return dt.iterator ();
  }
  
  public static Iterator getIterator (DGraph dg)
  {
    log.debug ("Start Hi! DGraph");
    DGDepthTraverse dt = new DGDepthTraverse (dg);
    return dt.iterator ();
  }

  private DGDepthTraverse (DGNode xk)
  {
    nodes = new ArrayList ();
    nodes.add (xk);
    doChildrenOf (xk);
  }

  private DGDepthTraverse (DGraph xk)
  {
    nodes = new ArrayList ();
    for (Iterator it = xk.getRootNodes ().iterator (); it.hasNext ();)
      {
	log.debug ("  Hi! dg");
	DGNode next = (DGNode) it.next ();
	if (!nodes.contains (next))
	  nodes.add(next);
	doChildrenOf (next);
      }
  }
  
  private void doChildrenOf (DGNode state)
  {
    for (Iterator it = state.getSuccessors ().iterator (); it.hasNext ();)
      {
	DGNode next = (DGNode) it.next ();
	if (!nodes.contains (next))
	  {
	    log.debug ("      Hi! dgn");
	    nodes.add (next);
	    doChildrenOf (next);
	  }
      }
  }

  public Iterator iterator ()
  {
    log.debug ("DGDT: Iterator: "+nodes);
    return nodes.iterator ();
  }
  
}
