package edu.toronto.cs.util.dgraph;

import java.util.*; // We all love java.util ...



public class DGraph
{
  Set rootNodes;
  DGNodeFactory factory;

  public DGraph (DGNodeFactory _factory)
    {
      rootNodes = new HashSet ();
      factory = _factory;
    }
  
  public boolean isRootNode (DGNode node)
  {
    return rootNodes.contains (node);
  }
  
  public DGNodeFactory getFactory ()
    {
      return factory;
    }
  
  public void addRootNode (DGNode _rootNode)
    {
      if (isOkToAdd(_rootNode))
	{
	  rootNodes.add (_rootNode);
	  _rootNode.setGraph (this);
	  // _rootNode.setRootNode (true);
	}
    }
  
  public Set getRootNodes ()
    {
      return rootNodes;
    }
  
  /*
  public void addSuccessorTo (DGNode node1, DGNode node2)
    {
      if (!isOkToAdd (node2))
	return;
        if (node1.owner.addOk (node2))
	  { 
	    node1.addSuccessor (node2);
	    node2.addedTo (this);
	  }
    }
  */
  
  public boolean isOkToAdd (DGNode node)
    {
      return ((node.getGraph () == this) 
	      || (node.getGraph () == null));
    }
  
}



